/*----------------------------------------------------------------------------
 Copyright:      Thomas Heldt  mailto: thomas@heldt-web.de
 Author:         Thomas Heldt
 Remarks:
 known Problems: untested
 Version:        11.11.2007
 Description:    Webserver Applikation for send a Mail
----------------------------------------------------------------------------*/

#include "smtp.h"

void mail_send (void)
{
	//ffnet eine Verbindung zu meinem Webserver
	MAIL_DEBUG("ARP Request to Mailserver\n\r");
	unsigned long destip;
	destip =SMTP_IP;
	unsigned int my_mail_cp;

	my_mail_cp = time;

	add_tcp_app (my_mail_cp, (void(*)(unsigned char))mail);

	//ARP Request senden
	arp_request (destip);
	for(unsigned long a=0;a<2000000;a++){asm("nop");};

	tcp_port_open (destip,LBBL_ENDIAN_INT(25),LBBL_ENDIAN_INT(my_mail_cp));
}

//----------------------------------------------------------------------------
//Mail senden
void mail (unsigned char index)
{
 	char * start_data = (char*)&eth_buffer[TCP_DATA_START_VAR];
	char * str_pointer;

	MAIL_DEBUG("Mail Anwendung gestartet %s\r\n",tcp_entry[index].app_status);

	for(unsigned int a=TCP_DATA_START_VAR;a<(TCP_DATA_END_VAR);a++)
	{
		MAIL_DEBUG("%c",eth_buffer[a]);
	}

	str_pointer = strcasestr(start_data,"220");
	if ((str_pointer != 0))
	{
		MAIL_DEBUG("220 EMPFANGEN, SENDE HELO\r\n");

		memmove(&eth_buffer[TCP_DATA_START],"HELO XXXXXXXXXXXXXXXX\r\n",LL);
		tcp_entry[index].app_status=1;

		//Erzeugte Packet kann nun gesendet werden!
		create_new_tcp_packet(LL,index);

		tcp_entry[index].time = TCP_TIME_OFF;
		return;
	}

	if(tcp_entry[index].app_status==2)
	{
		str_pointer = strcasestr(start_data,"250");
		if ((str_pointer != 0))
		{
			MAIL_DEBUG("250 EMPFANGEN, SENDE MAIL FROM\r\n");

			memmove(&eth_buffer[TCP_DATA_START],"MAIL FROM:<XXXXX@YYYYYYYYYYYYY>\r\n",LL);

			//Erzeugte Packet kann nun gesendet werden!
			create_new_tcp_packet(LL,index);

			tcp_entry[index].time = TCP_TIME_OFF;
			return;
		}
	}

	if(tcp_entry[index].app_status==3)
	{
		str_pointer = strcasestr(start_data,"250");
		if ((str_pointer != 0))
		{
			MAIL_DEBUG("250 EMPFANGEN, SENDE RCPT TO\r\n");

			memmove(&eth_buffer[TCP_DATA_START],"RCPT TO:<XXXXX@YYYYYYYYYYYYY>\r\n",LL);

			//Erzeugte Packet kann nun gesendet werden!
			create_new_tcp_packet(LL,index);

			tcp_entry[index].time = TCP_TIME_OFF;
			return;
		}
	}

	if(tcp_entry[index].app_status==4)
	{
		str_pointer = strcasestr(start_data,"250");
		if ((str_pointer != 0))
		{
			MAIL_DEBUG("250 EMPFANGEN, SENDE DATA\r\n");

			memmove(&eth_buffer[TCP_DATA_START],"DATA\r\n",6);

			//Erzeugte Packet kann nun gesendet werden!
			create_new_tcp_packet(6,index);

			tcp_entry[index].time = TCP_TIME_OFF;
			return;
		}
	}

	if(tcp_entry[index].app_status==5)
	{
		str_pointer = strcasestr(start_data,"354");
		if ((str_pointer != 0))
		{
			MAIL_DEBUG("354 EMPFANGEN, SENDE MAILTEXT\r\n");

			memmove(&eth_buffer[TCP_DATA_START],"From: XXXXXXXXX@YYYYYYYYYYYYYY\r\nTo: XXXXXXXXX@YYYYYYYYYYYYYY\r\nSubject:AVR-Serverstart\r\n\r\nAVR Server gestartet!\r\n.\r\n",LL);

			//Erzeugte Packet kann nun gesendet werden!
			create_new_tcp_packet(LL,index);

			tcp_entry[index].time = TCP_TIME_OFF;
			return;
		}
	}

	str_pointer = strcasestr(start_data,"250");
	if ((str_pointer != 0))
	{
		MAIL_DEBUG("250 EMPFANGEN, SENDE QUIT\r\n");

		memmove(&eth_buffer[TCP_DATA_START],"QUIT\r\n",6);

		//Erzeugte Packet kann nun gesendet werden!
		create_new_tcp_packet(6,index);

		tcp_entry[index].time = 0;
		return;
	}

	if(tcp_entry[index].app_status>6 && tcp_entry[index].app_status<0xFFFF)
	{
		MAIL_DEBUG("BYE EMPFANGEN\r\n");
		tcp_Port_close(index);
		return;
	}

	//Verbindung kann geschlossen werden! Alle Daten wurden gesendet TCP Port kann
	//geschlossen werden (tcp_entry[index].app_status == 0xFFFE)!!
	tcp_index_del(index);
	return;
}
